From 7371d3ae92b06eb7d88c6bf795c6cd82ef044964 Mon Sep 17 00:00:00 2001
From: Zhang Yu <zhangyub@uniontech.com>
Date: Tue, 17 Nov 2020 21:05:39 +0800
Subject: [PATCH 067/262] Fix QGraphicsItem crash if click right button of
 mouse

In this case, the 'parent' is QGraphicsTextItem which isn't a object
inheriting from QWidget. Converting QGraphicsTextItem to QWidget
by static_cast and using it as QWidget leads to crash.

Fixes: QTBUG-88309
Change-Id: I3c583f43125eb36841848434d1fa9a135b0e9f57
Reviewed-by: Volker Hilsheimer <volker.hilsheimer@qt.io>
(cherry picked from commit 4df5f93018344f6cdc6cd5a08a084b1c61e0c076)
---
 src/widgets/widgets/qwidgettextcontrol.cpp | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

diff --git a/src/widgets/widgets/qwidgettextcontrol.cpp b/src/widgets/widgets/qwidgettextcontrol.cpp
index 40b8af663c..e2a07c0043 100644
--- a/src/widgets/widgets/qwidgettextcontrol.cpp
+++ b/src/widgets/widgets/qwidgettextcontrol.cpp
@@ -1942,10 +1942,14 @@ void QWidgetTextControlPrivate::contextMenuEvent(const QPoint &screenPos, const
     if (!menu)
         return;
     menu->setAttribute(Qt::WA_DeleteOnClose);
-    if (auto *window = static_cast<QWidget *>(parent)->window()->windowHandle()) {
-        QMenuPrivate::get(menu)->topData()->initialScreenIndex =
+
+    if (auto *widget = qobject_cast<QWidget *>(parent)) {
+        if (auto *window = widget->window()->windowHandle()) {
+            QMenuPrivate::get(menu)->topData()->initialScreenIndex =
                 QGuiApplication::screens().indexOf(window->screen());
+        }
     }
+
     menu->popup(screenPos);
 #endif
 }
-- 
2.33.0

#From 6344955d17e17e2398720fe60c34cfc2a4a95208 Mon Sep 17 00:00:00 2001
#From: Liang Qi <liang.qi@qt.io>
#Date: Tue, 17 Nov 2020 11:07:30 +0100
#Subject: [PATCH 068/262] Bump version
#
#Change-Id: I5697edf968dfaebe25c73899d26ed234631e55dc
#Reviewed-by: Kevin Funk <kevin.funk@kdab.com>
#Reviewed-by: Jani Heikkinen <jani.heikkinen@qt.io>
#---
# .qmake.conf | 2 +-
# 1 file changed, 1 insertion(+), 1 deletion(-)
#
#diff --git a/.qmake.conf b/.qmake.conf
#index 9476d20099..1bf1a80475 100644
#--- a/.qmake.conf
#+++ b/.qmake.conf
#@@ -6,4 +6,4 @@ DEFINES += QT_NO_JAVA_STYLE_ITERATORS
# QT_SOURCE_TREE = $$PWD
# QT_BUILD_TREE = $$shadowed($$PWD)
# 
#-MODULE_VERSION = 5.15.2
#+MODULE_VERSION = 5.15.3
#-- 
#2.33.0
#
